Program Simple3d;
{$N+}
uses crt,spx_vga,spx_joy,graph3d;
type
  pointrec=record
    xpos : double;
    ypos : double;
    zpos : double;
    color : integer
  end;
  alpha_array=array[0..28] of byte;
var
  setupmode : integer;
  flightmode : integer;
  gyn : integer;
  gmag : double;
  points : array[0..999] of pointrec;
 {vx,vy,vz : double;}
 {xr,yr,zr : integer;}
  xt,yt,zt : double;
  xgrav,ygrav,zgrav : double;
  ef : double;
  x,y,z : integer;
  ch : char;
  c : integer;
  jx0,jx1,jy0,jy1 : integer;
  jcx,jcy : integer;
  alphas : array [1..96] of alpha_array;
  alphafile : file of alpha_array;
  q,r,ss : integer;
  jn : integer;

function vmag(ii,ij,ik : double) : longint;
begin
  vmag:=round(sqrt(sqr(ii)+sqr(ij)+sqr(ik)));
end;

function vmd(ii,ij,ik : double) : double;
begin
  vmd:=sqrt(sqr(ii)+sqr(ij)+sqr(ik));
end;


Procedure GetSmallFont;
Begin
  assign(alphafile,'5X5NEW.FON');
  reset(alphafile);
  for x:=1 to 96 do
  begin
    seek(alphafile,x);
    read(alphafile,alphas[x])
  end;
  close(alphafile);
end;


Procedure TPrtXY(a,b : integer; i : string);
Begin
  x:=length(i);
  if (x=0) then exit;
  for y:=1 to x do
  begin
    q:=ord(i[y]);
    z:=(q-31);                  {shift index for ALPHAS array}
    r:=(y-1);
    ss:=((6*r)+a);
    ftput(ss,b,alphas[z],false)
  end;
end;

Procedure CTPrtXY(a,b : integer; i : string; color : byte);
Begin
  x:=length(i);
  if (x=0) then exit;
  for y:=1 to x do
  begin
    q:=ord(i[y]);
    z:=(q-31);                  {shift index for ALPHAS array}
    r:=(y-1);
    ss:=((6*r)+a);
    for q:=0 to 28 do
    begin
      if (alphas[z][q]=15) then alphas[z][q]:=color
    end;
    ftput(ss,b,alphas[z],false);
    for q:=0 to 28 do
    begin
      if (alphas[z][q]=color) then alphas[z][q]:=15
    end
  end;
end;


Procedure calibrate_stick;
Begin
  clrscr;
  if (not joy1there) then
  begin
    writeln('No joystick found!');
    exit
  end;
  write('Move joystick to upper-left & press button #1...  ');
  repeat
    setstick(1);
    gotoxy(1,2);
    write('X: ',stickx[1],' Y: ',sticky[1],'           ')
  until button1[1];
  jx0:=stickx[1];
  jy0:=sticky[1];
  gotoxy(1,1);
  delay(1000);
  write('Move joystick to lower-right & press button #1...  ');
  repeat
    setstick(1);
    gotoxy(1,2);
    write('X: ',stickx[1],' Y: ',sticky[1],'           ')
  until button1[1];
  jx1:=stickx[1];
  jy1:=sticky[1];
  gotoxy(1,1);
  delay(1000);
  write('Move joystick to center & press button #2...        ');
  repeat
    setstick(1);
    gotoxy(1,2);
    write('X: ',stickx[1],' Y: ',sticky[1],'           ')
  until button2[1];
  jcx:=stickx[1];
  jcy:=sticky[1];
  writeln;
  writeln('Joystick Calibrated.');
  jcx:=round((jx0+jx1)/2);
  jcy:=round((jy0+jy1)/2);
  writeln('XMAX: ',jx1,' YMAX: ',jy1,' XMIN: ',jx0,' YMIN: ',jy0,' XC: ',jcx,' YC: ',jcy);
  writeln('Press button #1 to continue.');
  repeat
    setstick(1)
  until button1[1];
  writeln;
end;


Procedure setup;
var
  gch : char;
  cc : integer;
  ci : integer;
  pc : integer;
  radius : double;
  a1,a2 : integer;
  cx : char;
  pf : file of rgblist;
  thepal : rgblist;
begin
  assign(pf,'PAL.DAT');
  reset(pf);
  seek(pf,0);
  read(pf,thepal);
  close(pf);
  setupmode:=0;
  calibrate_stick;
  jn:=100;
  getsmallfont;
  maketables;
  ef:=200;
 {xr:=0;
  yr:=0;
  zr:=0;}
  xt:=0;
  yt:=0;
  zt:=0;
  gmag:=1;
  clrscr;
  writeln('Enter Setup Mode : ');
  writeln('   0 = random');
  writeln('   1 = sinewave strip');
  writeln('   2 = cylinder');
  writeln('   3 = spiral');
  writeln('   4 = cone spiral');
  writeln;
  write(' Choice : ');
  readln(setupmode);
  writeln;
  writeln('Enter Flight Mode : ');
  writeln('   0 = No Inertia - ie like Wing Commander');
  writeln('   1 = "Real World" modeling - more difficult');
  writeln;
  write(' Choice : ');
  readln(flightmode);
  writeln;
  writeln('Do you want gravity (towards the origin)? [y/N] : ');
  readln(gch);
  gch:=upcase(gch);
  if (gch='Y') then gyn:=1 else gyn:=0;
  if (setupmode=0) then
  begin
    for c:=0 to 999 do
    begin
      x:=(random(20000)-10000);
      y:=(random(20000)-10000);
      z:=(random(20000)-10000);
      points[c].xpos:=x*1.0;
      points[c].ypos:=y*1.0;
      points[c].zpos:=z*1.0;
      points[c].color:=(random(255)+1);
    end
  end;
  if (setupmode=1) then
  begin
    pc:=0;
    for c:=0 to 24 do
    begin
      for cc:=0 to 39 do
      begin
        points[pc].xpos:=(30*cc);
        points[pc].ypos:=(50*sin((2*cc)/(2*pi)));
        points[pc].zpos:=c;
        points[pc].color:=round(((abs(sin((2*cc)/(2*pi))))*8)+33);
        if (points[pc].color>41) then points[pc].color:=41;
        if (points[pc].color<33) then points[pc].color:=33;
        inc(pc)
      end
    end
  end;
  if (setupmode=2) then
  begin
    radius:=1000;
    for c:=0 to 999 do
    begin
      a1:=random(360);
      a2:=random(360);
      points[c].xpos:=1.0*(radius*sin(dr(a1)));
      points[c].zpos:=1.0*(radius*cos(dr(a1)));
      points[c].ypos:=1.0*(radius*cos(dr(a2)));
      points[c].color:=random(255)+1;
    end
  end;
  if (setupmode=3) then
  begin
    radius:=200;
    pc:=0;
    a1:=0;
    ci:=16;
    for c:=0 to 999 do
    begin
      points[c].xpos:=(radius*cost[a1]);
      points[c].ypos:=(radius*sint[a1]);
      points[c].zpos:=c/2;
      points[c].color:=ci;
      a1:=(a1+2);
      ci:=(ci+1);
      if (ci=256) then ci:=16;
      if (a1=360) then a1:=0;
      inc(pc)
    end
  end;
  if (setupmode=4) then
  begin
    radius:=10;
    a1:=0;
    ci:=16;
    for c:=0 to 999 do
    begin
      points[c].xpos:=(radius*cost[a1]);
      points[c].ypos:=(radius*sint[a1]);
      points[c].zpos:=2*c;
      points[c].color:=ci;
      a1:=(a1+2);
      ci:=(ci+1);
      radius:=(radius+2);
      if (ci=256) then ci:=16;
      if (a1=360) then a1:=0
    end
  end;
  xgrav:=0.0;
  ygrav:=0.0;
  zgrav:=0.0;
  if (gyn=1) then
  begin
    for c:=0 to 999 do
    begin
      points[c].zpos:=points[c].zpos-1000
    end;
    zgrav:=-1000.0
  end;
  openmode(3);
  fsetcolors(thepal);
  setpageactive(3);
  cls(0);
  setpageactive(2);
End;

procedure plotpoints;
var
  kx,ky,kz : double;
  kx0,ky0,kz0,kx1,ky1,kz1 : double;
  sx,sy : longint;
  lx,ly : double;
  odist : double;
  gm2 : double;
begin
  if (gyn=1) then
  begin
    odist:=vmd(xgrav,ygrav,zgrav);
    if (odist<>0) then
    begin
      gm2:=(gmag/(sqr(odist)));
      xt:=(xt+((xgrav/odist)*gm2));
      yt:=(yt+((ygrav/odist)*gm2));
      zt:=(zt+((zgrav/odist)*gm2))
    end
  end;
  for y:=0 to 999 do
  begin
    {
    rotatexyz(xr,yr,zr,points[y].xpos,points[y].ypos,points[y].zpos,
              kx,ky,kz);
    }
    points[y].xpos:=points[y].xpos-xt;
    points[y].ypos:=points[y].ypos-yt;
    points[y].zpos:=points[y].zpos-zt;
    {
    rotate3x(xr,points[y].xpos,points[y].ypos,points[y].zpos,kx0,ky0,kz0);
    rotate3y(yr,kx0,ky0,kz0,kx1,ky1,kz1);
    rotate3z(zr,kx1,ky1,kz1,kx,ky,kz);
    }
    kx:=points[y].xpos;
    ky:=points[y].ypos;
    kz:=points[y].zpos;
    if (kz>0) then
    begin
      lx:=((kx*ef)/kz)*1.0;
      ly:=((ky*ef)/kz)*1.0;
      lx:=lx+160;
      ly:=ly+100;
      if ((lx>=0) and (lx<=319) and (ly>=0) and (ly<=199)) then
      begin
        sx:=round(lx);
        sy:=round(ly);
        pset(sx,sy,points[y].color)
      end
    end
  end;
  xgrav:=xgrav-xt;
  ygrav:=ygrav-yt;
  zgrav:=zgrav-zt;
End;

procedure mainloop;
var
  qx,qy,qz : double;
  gx,gy,gz : double;
  ggx,ggy,ggz : double;
  rspeed : integer;
  dx,dy : integer;
  r0,r1 : double;
  spin : integer;
  yaks : string;
  yaks1 : string;
  yaks2 : string;
begin
  rspeed:=1;
  repeat
    ch:=chr(0);
    plotpoints;
    circle(160,100,20,15);
    circle(160,100,18,9);
    line(160,90,160,110,12);
    line(150,100,170,100,12);
    bar(0,0,110,40,8);
    str((vmag(xt,yt,zt)),yaks);
    yaks1:='SPEED = '+yaks+'  ';
    ctprtxy(4,4,yaks1,10);
    str(rspeed,yaks);
    yaks1:='ROTSPD= '+yaks+'  ';
    ctprtxy(4,12,yaks1,11);
    str(jn,yaks);
    yaks1:='NULLZONE = '+yaks+'   ';
    ctprtxy(4,20,yaks1,9);
    str(round(gmag),yaks);
    str(vmag(xgrav,ygrav,zgrav),yaks2);
    yaks1:='GMAG = '+yaks+'/'+yaks2+'                              ';
    ctprtxy(4,28,yaks1,13);
    fpcopy(pages[2]^,pages[1]^);
    fpcopy(pages[3]^,pages[2]^);
    setstick(1);
    setstick(2);
    if ((abs(stickx[1]-jcx))>jn) then
    begin
      r1:=(abs(stickx[1]-jcx))/(abs(jx1-jcx));
      dx:=round(4*r1);
      if (stickx[1]<jcx) then dx:=(-1*dx)
    end else dx:=0;
    dx:=(-1*dx);
    if (dx<0) then dx:=(dx+360);
    for c:=0 to 999 do
    begin
      rotate3y(dx,points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
      points[c].xpos:=qx;
      points[c].ypos:=qy;
      points[c].zpos:=qz
    end;
    rotate3y(dx,xgrav,ygrav,zgrav,ggx,ggy,ggz);
    xgrav:=ggx;
    ygrav:=ggy;
    zgrav:=ggz;
    if (flightmode=1) then
    begin
      rotate3y(dx,xt,yt,zt,gx,gy,gz);
      xt:=gx;
      yt:=gy;
      zt:=gz
    end;
    if ((abs(sticky[1]-jcy))>jn) then
    begin
      r0:=(abs(sticky[1]-jcy))/(abs(jy1-jcy));
      dy:=round(4*r0);
      if (sticky[1]<jcy) then dy:=(-1*dy)
    end else dy:=0;
    dy:=(-1*dy);
    if (dy<0) then dy:=(dy+360);
    for c:=0 to 999 do
    begin
      rotate3x(dy,points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
      points[c].xpos:=qx;
      points[c].ypos:=qy;
      points[c].zpos:=qz
    end;
    rotate3x(dy,xgrav,ygrav,zgrav,ggx,ggy,ggz);
    xgrav:=ggx;
    ygrav:=ggy;
    zgrav:=ggz;
    if (flightmode=1) then
    begin
      rotate3x(dy,xt,yt,zt,gx,gy,gz);
      xt:=gx;
      yt:=gy;
      zt:=gz
    end;
    if (button1[1]=true) then spin:=6
    else if (button2[1]=true) then spin:=354 else spin:=0;
    for c:=0 to 999 do
    begin
      rotate3z(spin,points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
      points[c].xpos:=qx;
      points[c].ypos:=qy;
      points[c].zpos:=qz
    end;
    rotate3z(spin,xgrav,ygrav,zgrav,ggx,ggy,ggz);
    xgrav:=ggx;
    ygrav:=ggy;
    zgrav:=ggz;
    if (flightmode=1) then
    begin
      rotate3z(spin,xt,yt,zt,gx,gy,gz);
      xt:=gx;
      yt:=gy;
      zt:=gz
    end;
    if (button1[2]=true) then zt:=(zt+2);
    if (button2[2]=true) then zt:=(zt-2);
    if keypressed then ch:=readkey;
    ch:=upcase(ch);
    if (ch=']') then inc(rspeed);
    if (ch='[') then dec(rspeed);
    if (ch='+') then jn:=(jn+5);
    if (ch='-') then jn:=(jn-5);
    if (ch='H') then gmag:=(gmag*10);
    if (ch='G') then gmag:=(gmag/10);
    if (rspeed<0) then rspeed:=0;
    if (ch='A') then
    begin
      for c:=0 to 999 do
      begin
        rotate3y(rspeed,points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
        points[c].xpos:=qx;
        points[c].ypos:=qy;
        points[c].zpos:=qz
      end
    end;
    if (ch='D') then
    begin
      for c:=0 to 999 do
      begin
        rotate3y((360-rspeed),points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
        points[c].xpos:=qx;
        points[c].ypos:=qy;
        points[c].zpos:=qz
      end
    end;
    if (ch='W') then
    begin
      for c:=0 to 999 do
      begin
        rotate3x(rspeed,points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
        points[c].xpos:=qx;
        points[c].ypos:=qy;
        points[c].zpos:=qz
      end
    end;
    if (ch='X') then
    begin
      for c:=0 to 999 do
      begin
        rotate3x((360-rspeed),points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
        points[c].xpos:=qx;
        points[c].ypos:=qy;
        points[c].zpos:=qz
      end
    end;
    if (ch='Q') then
    begin
      for c:=0 to 999 do
      begin
        rotate3z(rspeed,points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
        points[c].xpos:=qx;
        points[c].ypos:=qy;
        points[c].zpos:=qz
      end
    end;
    if (ch='E') then
    begin
      for c:=0 to 999 do
      begin
        rotate3z((360-rspeed),points[c].xpos,points[c].ypos,points[c].zpos,qx,qy,qz);
        points[c].xpos:=qx;
        points[c].ypos:=qy;
        points[c].zpos:=qz
      end
    end;
    if (ch='I') then zt:=(zt+2);
    if (ch='M') then zt:=(zt-2);
    if (ch='J') then xt:=(xt-2);
    if (ch='K') then xt:=(xt+2);
    if (ch='U') then yt:=(yt+2);
    if (ch='N') then yt:=(yt-2);
    if (ch='*') then
    begin
      xt:=0;
      yt:=0;
      zt:=0;
    end;
   {if (ch='&') then
    begin
      xr:=0;
      yr:=0;
      zr:=0;
    end;}
    {
    if (xr<0) then xr:=(xr+360);
    if (yr<0) then yr:=(yr+360);
    if (zr<0) then zr:=(zr+360);
    if (xr>360) then xr:=(xr-360);
    if (yr>360) then yr:=(yr-360);
    if (zr>360) then zr:=(zr-360);
    }
  until (ch=chr(27));
  closemode;
End;


begin
  setup;

  mainloop;
End.

